import times, unittest
import ./testutil
import ../../main/nim/strawbosspkg/configuration
import ../../main/nim/strawbosspkg/server

let testuser = UserRef( # note: needs to correspond to an actual user
  name: "bob@builder.com",
  hashedPwd: "$2a$11$lVZ9U4optQMhzPh0E9A7Yu6XndXblUF3gCa.zmEvJy4F.4C4718b.")

let cfg = loadStrawBossConfig("src/test/json/strawboss.config.json")

## UNIT TESTS
suite "strawboss server":
  test "can validate hashed pwd":
    check validatePwd(testuser, "password")

  test "can detect invalid pwds":
    check (not validatePwd(testuser, "Password"))

  test "can make and extract a JWT token from a session":
    let session = newSession(testuser)
    let tok = toJWT(cfg, session)

    check:
      fromJWT(cfg, tok) == session
